program prjHookHeap;

{ Small test/demo program to demonstrate my > heaptrc.pp <
  WITH CLASSNAME reporting of leaked objects
  and
  HeapNotification callback to track construction/destruction of TObject instances }

uses
  Classes,
  SysUtils;

var
  lCreateStep : integer = 0;
  lLogFileName : string;
  LostMemory:tobject;
  StupidPointer:Pointer;

procedure HeapNotification(Sender: TObject; aDestroy : boolean);
begin
  if Assigned(Sender) then
    case aDestroy of
      False:WriteLn(Sender.ClassName, ' NewInstance  Step=', lCreateStep);
      True: WriteLn(Sender.ClassName, ' FreeInstance Step=', lCreateStep);
    end;
end;

begin
{$if declared(UseHeapTrace)}
  SetHeapNotification(@HeapNotification); // <-- Heaptrc callback for TObject's
  lLogFileName := ChangeFileExt(ParamStr(0), '_log.txt');
  if FileExists(lLogFileName) then
    DeleteFile(lLogFileName);
  SetHeapTraceOutput(lLogFileName); // ~bk debug heap
  HeapLogTextStart:=ExtractFilename(ParamStr(0))+' HeapTrc START session : '+DateTimeToStr(Now);
  GlobalSkipIfNoLeaks := true; // supported as of debugger version 3.1.1
{$endif}
  lCreateStep := 0;
  StupidPointer:=GetMem(100000);
  ReallocMem(StupidPointer, 50000);
  FreeMem(StupidPointer);
  lCreateStep := 1;
  LostMemory:=TObject.create;
  LostMemory.Free;
  lCreateStep := 2;
  LostMemory:=TObject.create;
  StupidPointer:=GetMem(129);
  lCreateStep := 3;
  LostMemory:=TList.Create;
  LostMemory.Free;
  lCreateStep := 4;
  LostMemory:=TList.Create;
  lCreateStep := 5;
  LostMemory:=TComponent.create(nil);
  lCreateStep := 6;
  LostMemory:=TFPList.Create;
  WriteLn('Press ENTER to Quit');
  ReadLn;
  {$if declared(UseHeapTrace)}
  HeapLogTextEnd:=ExtractFilename(ParamStr(0))+' HeapTrc END THeaptrcObject. : '+DateTimeToStr(Now);
  {$endif}

end.

